package com.logicbig.example;

import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import java.util.List;

public interface AppResource<T> {

    @PUT
    @Path("{newId}")
    @Consumes(MediaType.APPLICATION_XML)
    String create(T t, @PathParam("newId") long newId);

    @DELETE
    @Path("{id}")
    String delete(@PathParam("id") long id);

    @POST
    @Consumes(MediaType.APPLICATION_XML)
    String update(T t);

    @GET
    @Produces(MediaType.APPLICATION_XML)
    List<T> list();

    @GET
    @Path("{id}")
    @Produces(MediaType.APPLICATION_XML)
    T byId(@PathParam("id") long id);
}